<?php
/*
Mage Forms
*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/* Basic plugin definitions */
/*
 * @level 		Casting
 * @author		Mage Cast 
 * @url			http://magecast.com
 * @license   	http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */
?>
<?php
if (!defined('MAGECAST_FORMS')) exit;
add_action('init', 'summon_magecast_forms');
add_filter('mage_forms_validate', 'mage_forms_options');
add_action( 'wp_enqueue_scripts', 'enqueue_scribe_scripts');
add_action('admin_init', 'summon_scrolls');
function enqueue_scribe_scripts() {
	global $post, $bp;
	$id = $action = '';
	if (!is_object($post)) return;
	if (!has_shortcode($post->post_content,'form'))return;
	if (is_multisite())require_once ABSPATH . '/wp-admin/includes/ms.php';
	wp_enqueue_style('mage-form',MAGECAST_FORMS_SOURCE.'css/mage-forms.css');
	wp_enqueue_script('select',MAGECAST_FORMS_SOURCE.'js/select2.min.js', array('jquery'));
	wp_enqueue_script('mage-components',MAGECAST.'js/bootstrap.min.js',array('jquery'),'3.0.0',true);
		
  	wp_enqueue_script('plupload-handlers');
	wp_enqueue_script('jquery-ui-sortable');				 	
	if (wp_script_is('plupload-handlers')){	
		$plup = array(
			'runtimes' => 'html5,silverlight,flash,html4',
			'browse_button' => 'mage-form-upload-button',
			'file_data_name' => 'mage_img_upload',
			'max_file_size' => wp_max_upload_size() . 'b',
			'url' => admin_url( 'admin-ajax.php' ) . '?action=mage_img_upload&nonce=' . wp_create_nonce( 'mage_img_upload' ),
           	'flash_swf_url' => includes_url( 'js/plupload/plupload.flash.swf' ),
        	'silverlight_xap_url' => includes_url( 'js/plupload/plupload.silverlight.xap' ),
       		'filters' => array(array('title' => __( 'Allowed Files' ), 'extensions' => '*')),
      		'multipart' => true,
       		'urlstream_upload' => true,
       	);
		$atts = array(
			'ajaxurl' => admin_url( 'admin-ajax.php' ),
			'mage_status_submit' => 'Submitting',
			'mage_status_confirm' => 'Are you sure?',
			'nonce' => wp_create_nonce( 'scribe_nonce' ),
			'plupload' => $plup
    	);
		wp_enqueue_script('scribe', MAGECAST_FORMS_SOURCE.'js/scribe.js', array('jquery'));
    	wp_localize_script('scribe', 'scribe', $atts);	
		
		wp_enqueue_script('mage_attachment', MAGECAST_FORMS_SOURCE.'js/attachment.js', array('jquery'));
		wp_localize_script( 'mage_attachment', 'mage_attachment', array(
         	'nonce' => wp_create_nonce( 'mage_attachment' ),
            'number' => 5,
            'attachment_enabled' => true,
            'plupload' => array(
				'runtimes' => 'html5,flash,html4',
				'browse_button' => 'mage-form-attach-button',
				'container' => 'mage-form-attachments-wrap',
				'file_data_name' => 'mage_attachments',
				'max_file_size' => wp_max_upload_size() . 'b',
				'url' => admin_url( 'admin-ajax.php' ) . '?action=mage_upload_files&nonce=' . wp_create_nonce( 	'mage_upload_files' ),
				'flash_swf_url' => includes_url( 'js/plupload/plupload.flash.swf' ),
				'filters' => array(array('title' => __( 'Allowed Files' ), 'extensions' => '*')),
				'multipart' => true,
				'urlstream_upload' => true,
            )
       	));
	}
}

function summon_magecast_forms(){	
	if (current_user_can('switch_themes')) {	
		add_action('admin_init', 'mage_forms_init' );	
		add_action('admin_menu', 'summon_magecast_forms_dashboard');				
	}
}
function mage_forms_init() {			
		global $pagenow;	
		if('media-upload.php' == $pagenow || 'async-upload.php' == $pagenow )add_filter( 'gettext','replace_mage_upload_text',1,3);
		add_filter( 'mage_sanitize_text', 'sanitize_text_field' );
		add_filter( 'mage_sanitize_select', 'mage_sanitize_enum', 10, 2);
		add_filter( 'mage_sanitize_radio', 'mage_sanitize_enum', 10, 2);
		add_filter( 'mage_sanitize_legend', 'mage_sanitize_enum', 10, 2);
		add_filter( 'mage_sanitize_images', 'mage_sanitize_enum', 10, 2);
		add_filter( 'mage_sanitize_checkbox', 'mage_sanitize_checkbox' );
		add_filter( 'mage_sanitize_multicheck', 'mage_sanitize_multicheck', 10, 2 );
		add_filter( 'mage_sanitize_upload', 'mage_sanitize_upload' );
		$mage_settings = get_option('mage_forms');
		$id = 'mage_forms';
		if (isset($mage_settings['id'])){
			if ($mage_settings['id'] !== $id) { 
				$mage_settings['id'] = $id;
				update_option('mage_forms',$mage_settings);		
			}
		} else { 
			$mage_settings['id'] = $id;
			update_option('mage_forms',$mage_settings);
		}
		if (get_option($mage_settings['id']) === false) mage_setdefaults('forms');
		register_setting('mage_forms',$mage_settings['id'],'mage_forms_validate' );
	}
function summon_magecast_forms_dashboard(){
	global $themename, $shortname, $submenu, $menu;
	//$mage_forms_page = add_menu_page('Mage Forms Settings','Mage Forms','manage_options','mage_forms', 'edit.php?post_type=mage_form',MAGECAST_FORMS_SOURCE.'img/icon.png','27.9');
	$mage_forms_page = add_submenu_page('edit.php?post_type=mage_form', 'Mage Forms Settings', 'Help', 'manage_options', 'mage_forms', 'mage_forms_page');
	$submenu['edit.php?post_type=mage_form'][5][0] = 'Forms';
	add_action('admin_print_scripts-'.$mage_forms_page, 'mage_load_admin_scripts');			
	add_action('admin_print_styles-'.$mage_forms_page, 'mage_load_admin_styles' );
	add_action('admin_print_scripts-post.php', 'mage_form_scripts' );
	add_action('admin_print_scripts-post-new.php', 'mage_form_scripts' );	
}
function mage_form_scripts(){
	global $post;
	if ($post->post_type == 'mage_form'){
		wp_enqueue_script('alembic', MAGECAST_FORMS_SOURCE.'js/mage-forms.js', array('jquery'));
		wp_enqueue_script('mage-components',MAGECAST.'js/bootstrap.min.js',array('jquery'),'3.0.0',true);
		//add_filter('user_can_richedit' ,'__return_false', 50);
	}
}
function mage_forms_page() {
	global $craft;
?>
<div id="mage-wrap">
<?php settings_errors(); ?>
<div id="container" class="row">  
    <form id="mage-form" method="post" class="form-horizontal" action="options.php">
		<?php settings_fields('mage_forms'); ?>
		<div id="magecast-content" class="magecast-content tab-content"><?php fields(mage_forms_options(),'forms'); ?></div>
	<!-- Footer Navbar and Submit -->         
		<div class="navbar navbar-static-bottom">
            	<input type="submit" class="btn btn-brown" name="update" id="update" value="<?php esc_attr_e( 'Save Options', 'mage-forms' ); ?>" />        	
 		</div>
    </form>
</div>
</div><?php
}
function mage_forms_validate($input) {
	global $craft, $magecast;
	if (!current_user_can('manage_options'))die('Insufficient Permissions');
	$clean = array();
	$options = mage_forms_options();	
	foreach ($options as $option ){
		if (!isset($option['id']))continue;
		if (!isset($option['type']))continue;
		$id = cog($option['id']);
		if (!isset($input[$id])) {
			if (in_array($option['type'], array('text','textarea','select','radio','color','upload')))$input[$id] = isset($option['std'])? $option['std']:'';		
			if ('checkbox' == $option['type'])$input[$id] = false;				
			if ('multicheck' == $option['type'])$input[$id] = array();					
		}
		if (has_filter('mage_sanitize_' .$option['type'])){				
			$clean[$id] = apply_filters('mage_sanitize_' . $option['type'], $input[$id], $option);	
		} 
	}
	add_settings_error('mage_forms','save_options', __( 'Options Saved', 'mage-forms' ), 'updated modal fade in' );
	return $clean;
} 
function mage_forms_options(){
	//global $wp_roles;
	//$mage_roles = (array) $wp_roles->get_names();
	//$mage_roles['public'] = 'Public';
	//$pages = array(0=>'Redirect to Post') + mage_get_pages();
	//$users = array(0=>'Submitting User') + mage_get_users($args=array('role'=>'administrator'));
	$options = array();				
	$options[] = array('name' => 'Forms','icon' => 'star','type' => 'heading');	
	$options[] = array('name' => __('General','mage-forms'),'parent' => 'forms','type' => 'subheading');
	/*
	$options[] = array(
		'name' => __('Default Form Page','mage-forms'),
		'desc' => __('Choose the page where you will be placing your main [form] shortcode to use as the default edit page.','mage-forms'),
		'id' => 'mage_form_default_edit_page',		
		'type' => 'select',
		'options'=>mage_get_pages());
		/*
	$options[] = array(
		'name' => __('Shortcode Compatibility','mage-reviews'),
		'desc' => __('Prepend shortcodes with <code>mage_</code> for compatibility with other plugins.','mage-reviews'),
		'id' => 'mage_form_compatibility',		
		'type' => 'checkbox',
		'std' => '0');
		*/
	$options[] = array(		
		'content' => '<div class="alert alert-info" role="alert"><strong>Tip</strong> You may start by <a href="edit.php?post_type=mage_form">adding a form</a>.</div>',
		'type'=>'html');
	$options = apply_filters('mage_forms_attributes_general',$options);	
	$options[] = array(
		'name' => __('Debug Mode','mage-reviews'),
		'desc' => __('Enable WP Error output upon form submission on the front end.','mage-reviews'),
		'id' => 'mage_form_debug',		
		'type' => 'checkbox',
		'std' => '0');
		
	$options[] = array(
		'name' => __('Upcoming Features','mage-forms'),
		'type' => 'legend');
	$options[] = array(		
		'content' => '<ul>
		<li><strong>Edit Post (improved)</strong> Edit submitted posts via the same form.</li>
		<li><strong>Delete Post</strong> option to remove submitted content if enabled.</li>
		<li><strong>User Notification on Approval <strong style="color:#dd3333;">*</strong></strong> if enabled, so that a user with a pending post gets notified after its approved & published.</li>
		<li><strong>Customize Success/Error Alerts <strong style="color:#dd3333;">*</strong></strong> from the settings, in addition to being translatable.</li>	
		<li><strong>User Dashboard <strong style="color:#dd3333;">*</strong></strong> for managing submitted content.</li>
		</ul>
		<p><strong style="color:#dd3333;">*</strong> - pending feature until requested</p>
		<p>Feel free to submit other ideas or request already listed ones to confirm its usefulness.</p>
		',
		'type'=>'html');
	$options[] = array(
		'type' => 'html',
		'for'=>'legend');
	/*
	$options[] = array(
		'name' => __('Wording', 'mage-forms'),
		'desc' => __('Edit alert phrases throughout the form process.', 'mage-forms'),
		'type' => 'legend');
	$options[] = array(
		'name' => __('Submission Updated', 'mage-google-maps'),
		'id' => 'mage_forms_success',
		'std' => __('Your submission has been updated succesfully.','mage-forms'),
		'type' => 'text');		
	$options[] = array(
		'type' => 'html',
		'for'=>'legend');		
		
	$options[] = array('name' => __('Help','mage-forms'),'parent' => 'forms','type' => 'subheading');	
	*/
	$options[] = array(
		'name' => __('Form Element Shortcode','mage-forms'),
		'type' => 'legend');
	$options[] = array(		
		'content' => '<p>All Form elements share the following parameters.</p><table class="table">
          <thead>
            <tr>
              <th>'.__("Parameter",'mage-forms').'</th>
              <th>'.__("Type",'mage-forms').'</th>
			  <th>'.__("Description",'mage-forms').'</th>
              <th>'.__("Default",'mage-forms').'</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td><code>name</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__("The form elements unique name. This is required for all form elements.",'mage-forms').'</td>
              <td>'.__('empty','mage-forms').'</td>
            </tr>
            <tr>
              <td><code>label</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__("Prepend the form element with a label. This can also be done manually, without the usage of the shortcode parameter.",'mage-forms').'</td>
              <td>'.__('empty','mage-forms').'</td>
            </tr>
            <tr>
              <td><code>req</code></td>
              <td><div class="label label-warning">bool</div></td>
			  <td>'.__("Set a form element to be required. Required element labels will be marked with <strong>*</strong>, as well as pass through validation requirements accordingly. Works on all form elements.",'mage-forms').'</td>
              <td>0(1 to activate)</td>
            </tr>			
			<tr>
              <td><code>class</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__('Additional CSS classes to add to the form element.','mage-forms').'</td>
              <td>'.__('empty','mage-forms').'</td>
            </tr>
			<tr>
              <td><code>placeholder</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__('A form elements placeholder value. Applies only to some elements.','mage-forms').'</td>
              <td>'.__('empty','mage-forms').'</td>
            </tr>			
          </tbody>
        </table><p><strong>'.__('Usage','mage-forms').':</strong><br /><code>[text name="company" label="Business Name:" req=1 class="alignright" placeholder="Sample Media"]</code></p>',
		'type' => 'html');
		$options[] = array(
		'type' => 'html',
		'for'=>'legend');
		$options[] = array(
		'name' => __('[select] Shortcode','mage-forms'),
		'type' => 'legend');
		$options[] = array(		
		'content' => '<p>Parameters specific for <code>[select]</code> fields.</p><table class="table">
          <thead>
            <tr>
              <th>'.__("Parameter",'mage-forms').'</th>
              <th>'.__("Type",'mage-forms').'</th>
			  <th>'.__("Description",'mage-forms').'</th>
              <th>'.__("Default",'mage-forms').'</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td><code>name</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__('For a dynamic taxonomy dropdown, use "post_category" for categories or "tax_input" for custom taxonomies. Use any other name for an ordinary select dropdown.','mage-forms').'</td>
             <td>'.__('empty','mage-forms').'</td>
            </tr>
			<tr>
              <td><code>taxonomy</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__('If <strong>name</strong> is set to "tax_input", use the taxonomy slug here.','mage-forms').'</td>
              <td>'.__('empty','mage-forms').'</td>
            </tr>
            <tr>
              <td><code>show_option_none</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__("The text to display when no option is selected.",'mage-forms').'</td>
             <td>'.__('empty','mage-forms').'</td>
            </tr>
 		
			<tr>
              <td><code>options</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__('Comma separated list of options.','mage-forms').'</td>
              <td>'.__('empty','mage-forms').'</td>
            </tr>
			<tr>
              <td><code>selected</code></td>
              <td><div class="label label-primary">int</div></td>
			  <td>'.__('A term ID when using a taxonomy dropdown.','mage-forms').'</td>
             <td>'.__('empty','mage-forms').'</td>
            </tr>
          </tbody>
        </table><p><strong>'.__('Usage','mage-forms').':</strong><br /><code>[select name="tax_input" taxonomy="city" label="City:" req=1 show_option_none="Choose an Area" selected=7]</code></p>',
		'type' => 'html');	
	$options[] = array(
		'type' => 'html',
		'for'=>'legend');
	return $options;	
}


function mage_scroll_settings() {
	global $post;	
	$post_form = array(	
	'shortcode'=>array(
			'type'=>'shortcode',
			'code'=>'form',
			'label'=>'Shortcode'
		),
	);
	summon_mage_form_fields(array('id'=>$post->ID,'nonce'=>'mage_form_save'), $post_form, 2);
	global $wp_roles;
	$mage_roles = (array) $wp_roles->get_names();
	$mage_roles['public'] = 'Public';
	$pages = array(0=>'Redirect to Post') + mage_get_pages();
	$users = array(0=>'Submitting User') + mage_get_users($args=array('role'=>'administrator'));
	$pform = array(	
		'form_post_type' => array(
			'name'=> 'Post Type',
			'type'=>'select', 
			'options'=>mage_post_type_options(),
		),	
		'form_post_author' => array(
			'name'=> 'Post Author',
			'type'=>'select', 
			'options'=> $users
		),		
		'form_post_permission' => array(
			'name'=> 'Minimum Role',
			'type'=>'select', 
			'options'=> $mage_roles
		),		
	);		
	summon_mage_form_fields(array('id'=>$post->ID,'title'=>'Front End Form','class'=>'pform'), $pform,2);
	$pform = array(
		'form_post_status' => array(
			'name'=> 'Post Submit Status',
			'type'=>'select', 
			'options'=> array(
                    'publish' => 'Publish',
                    'draft' => 'Draft',
                    'pending' => 'Pending'
					)
		),
		'form_post_redirect' => array(
			'name'=> 'Form Submit Redirect',
			'type'=>'select', 
			'options'=> $pages
		),	
		'form_post_email' => array(
			'name'=> 'Post Notification Email',
			'type'=>'email',
			'std'=>get_option('admin_email'),
		),
		/*
		'form_post_edit' => array(
			'name'=> 'Allow Editing',
			'type'=>'checkbox'
		),*/
	);
	summon_mage_form_fields(array('id'=>$post->ID,'title'=>'Post Submit Settings','class'=>'pform'), $pform,2);
	$editing = array(	
	'shortcode'=>array(
			'type'=>'shortcode',
			'code'=>'mage_edit',
			'label'=>'Shortcode'
		),
	);
	summon_mage_form_fields(array('id'=>$post->ID,'title'=>'Edit Link','class'=>'pform','content'=>'Requires the ID of the page that the [form] is placed in, not the ID of the form itself. Should be placed within loop.'),$editing,2);
}
function mage_scroll_cast() {
	global $post;
	//$default = mage_get_option('email_handle') ? mage_get_option('email_handle'):get_option('admin_email');
	$craft = array(
		'form_email'=>array(
			'name'=>'Contact E-mail',
			'type'=>'email',
			//'std'=>$default,
			'req'=>'1',
			'size'=>'20'
		),
		'form_email_subject'=>array(
			'name'=>'Subject',
			'type'=>'text',
			'req'=>'1',
			'size'=>20
		),
		'form_email_body'=>array(
			'name'=>'Body',
			'type'=>'textarea',
			'req'=>'1',
			'rows' => '8'
		)			
	);		
	//summon_mage_form_fields($post->ID, $craft, 'form_save','cform');	
	$craft = array(
		'post_title'=>array(
			'name'=>'Title',
			'type'=>'shortcode',
			'std'=>'post_title',
			'code'=>'text'
		),
		'post_content'=>array(
			'name'=>'Content',
			'type'=>'shortcode',
			'std'=>'post_content'
		),
		'submit' => array(
			'label'=>'Submit Button',
			'type'=>'shortcode',
			'std'=>'submit',
			'code'=>'submit'
		),
	);
	summon_mage_form_fields(array('id'=>$post->ID,'title'=>'Required Elements','class'=>'pform','content'=>'If this is a Front End <strong>Post</strong> submission form, the following fields are required. Required fields may vary for pages or custom post type submission forms.'), $craft);
	$craft = array('post_excerpt'=>array(
			'name'=>'Excerpt',
			'type'=>'shortcode',
			'std'=>'post_excerpt'
		),
		'post_thumbnail'=>array(
			'name'=>'Featured Image',
			'type'=>'shortcode',
			'std'=>'post_thumbnail',
			'code' => 'upload'
		),
		/*'post_format'=>array(
			'name'=>'Post Format',
			'type'=>'shortcode',
			'std'=>'post_format',
			'code'=>'radio'
		),*/
		'post_category'=>array(
			'name'=>'Category',
			'type'=>'shortcode',
			'std'=>'post_category',
			'code'=>'select'
		),
		'tags_input'=>array(
			'name'=>'Tags',
			'type'=>'shortcode',
			'std'=>'tags_input',
			'code'=>'multicheck'
		),
		'post_attachments'=>array(
			'name'=>'Attachments',
			'type'=>'shortcode',
			'std'=>'post_attachments',
			'code' => 'attachments'
		),
		
		
		
	);		
	summon_mage_form_fields(array('id'=>$post->ID,'class'=>'pform','title'=>'Optional Elements','content'=>'Below are some commonly used fields for posts and pages that can be included for post types that support them.'), $craft);	
	$cast = array('custom_field_name'=>array(
			'name'=>'Custom Meta Field',
			'type'=>'shortcode',
			'std'=>'custom_field_name',
			'code'=>'text'
		),
		'tax_input'=>array(
			'name'=>'Custom Taxonomy',
			'type'=>'shortcode',
			'std'=>'tax_input',
			'code'=>'select',
			'parameters'=>'taxonomy="taxonomy_name"',
		),		
	);		
	summon_mage_form_fields(array('id'=>$post->ID,'class'=>'pform','title'=>'Custom Elements','content'=>'The following elements are for custom post meta fields and other usage examples.'), $cast);	
	//echo !empty($form)? mage_solve_form(false, $form, array(),'dump') : '';
}

function summon_scrolls() {
	add_meta_box('mage_scroll_cast', esc_html__( 'Form Elements', 'mage-forms' ), 'mage_scroll_cast', 'mage_form', 'normal','high');
	add_meta_box('mage_scroll_settings', esc_html__( 'Form Settings', 'mage-forms' ), 'mage_scroll_settings', 'mage_form', 'side','high');
	remove_meta_box('wpseo_meta', 'mage_form', 'normal');
	if (has_action('edit_form_advanced',array('post_type_generator', 'edit_form'))){
		remove_action('edit_form_advanced',array('post_type_generator', 'edit_form'));		
	}
	add_filter('manage_mage_form_posts_columns', 'mage_forms_column_titles');  	
	add_filter( 'manage_mage_form_posts_custom_column', 'mage_forms_column_data', 10, 2);
	if( is_admin() && get_option('mage_forms_activation') == 'activated') {
		delete_option('mage_forms_activation');
		flush_rewrite_rules();
	}	
	
}
function mage_forms_column_titles($columns) {
	unset($columns['date']);
    $columns['shortcode'] = 'Shortcode';
	$columns['form_type'] = 'Form Post Type';
	$columns['form_role'] = 'Role';
    return $columns;  
}
function mage_forms_column_data($column, $post_ID) {
	$cast = (array) maybe_unserialize( get_post_meta($post_ID,'cast',true) );
	switch ($column) {
        case 'shortcode':
           $out = '<code>[form id="'.$post_ID.'"]</code>';	
      	break;       
		case 'form_type':
			$post_type = isset($cast['mage_form_post_type'])? $cast['mage_form_post_type'] : '';
			$out = !empty($post_type)?'<strong>'.$post_type.'</strong>': '';	    	
      	break;		
		case 'form_role':
			$out = isset($cast['mage_form_post_type'])? $cast['mage_form_post_permission'] : '';	    	
      	break;	
    } 
	if (isset($out)) echo $out; 
}  